// ---- main.c ----

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>

#include "syntax.h"
#include "jobs.h"
//#include "intern.h"
#include "exec.h"


#define CWD_SIZE 64

/* gestion des signaux ^C et ^Z, mais ca marche pas ... */
/*  void handler (int sig) */
/*  { */
/*    kill_job (0, sig); */
/*  } */


int main (int argc, char **argv, char **env) {
  comm_t comm;
  int last_ret_val = 0;
  char cwd[CWD_SIZE];

/* gestion des signaux ^C et ^Z, mais ca marche pas ... */
/*    struct sigaction sa; */
  
/*    sa.sa_handler = &handler; */
/*    sa.sa_flags = 0; */
/*    sigemptyset (&(sa.sa_mask)); */

/*    sigaction (SIGINT, &sa, NULL); */
/*    sigaction (SIGTSTP, &sa, NULL); */

  init_job_tab ();
  
  printf ("Vos desirs sont des ordres, Maitre.\n");
  do {
    if (getcwd (cwd, CWD_SIZE))
      printf ("%c %s > ", (last_ret_val ? '!' : '-'), cwd);
    else
      printf ("%c /? > ", (last_ret_val ? '!' : '-'));

    fflush (stdout);
    comm = read_comm (stdin);
    update_print_if_dead_jobs (stdout);
    last_ret_val = exec_comm (comm);
    free_comm (comm);
  } while (1);

  return 0;
}

